"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReEmitter = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/*
Copyright 2015, 2016 OpenMarket Ltd
Copyright 2017 Vector Creations Ltd
Copyright 2017 New Vector Ltd

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var ReEmitter = /*#__PURE__*/function () {
  function ReEmitter(target) {
    (0, _classCallCheck2["default"])(this, ReEmitter);
    (0, _defineProperty2["default"])(this, "target", void 0);
    this.target = target;
  }

  (0, _createClass2["default"])(ReEmitter, [{
    key: "reEmit",
    value: function reEmit(source, eventNames) {
      var _this = this;

      var _iterator = _createForOfIteratorHelper(eventNames),
          _step;

      try {
        var _loop = function _loop() {
          var eventName = _step.value;

          // We include the source as the last argument for event handlers which may need it,
          // such as read receipt listeners on the client class which won't have the context
          // of the room.
          var forSource = function forSource() {
            var _this$target;

            // EventEmitter special cases 'error' to make the emit function throw if no
            // handler is attached, which sort of makes sense for making sure that something
            // handles an error, but for re-emitting, there could be a listener on the original
            // source object so the test doesn't really work. We *could* try to replicate the
            // same logic and throw if there is no listener on either the source or the target,
            // but this behaviour is fairly undesireable for us anyway: the main place we throw
            // 'error' events is for calls, where error events are usually emitted some time
            // later by a different part of the code where 'emit' throwing because the app hasn't
            // added an error handler isn't terribly helpful. (A better fix in retrospect may
            // have been to just avoid using the event name 'error', but backwards compat...)
            if (eventName === 'error' && _this.target.listenerCount('error') === 0) return;

            for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }

            (_this$target = _this.target).emit.apply(_this$target, [eventName].concat(args, [source]));
          };

          source.on(eventName, forSource);
        };

        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          _loop();
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }]);
  return ReEmitter;
}();

exports.ReEmitter = ReEmitter;