"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MatrixCall = exports.CallType = exports.CallState = exports.CallParty = exports.CallEvent = exports.CallErrorCode = exports.CallError = exports.CallDirection = void 0;
exports.createNewMatrixCall = createNewMatrixCall;
exports.getDesktopCapturerSources = getDesktopCapturerSources;
exports.setAudioInput = setAudioInput;
exports.setAudioOutput = setAudioOutput;
exports.setVideoInput = setVideoInput;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _logger = require("../logger");

var _events = require("events");

var utils = _interopRequireWildcard(require("../utils"));

var _event = require("../@types/event");

var _randomstring = require("../randomstring");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var CallState;
exports.CallState = CallState;

(function (CallState) {
  CallState["Fledgling"] = "fledgling";
  CallState["InviteSent"] = "invite_sent";
  CallState["WaitLocalMedia"] = "wait_local_media";
  CallState["CreateOffer"] = "create_offer";
  CallState["CreateAnswer"] = "create_answer";
  CallState["Connecting"] = "connecting";
  CallState["Connected"] = "connected";
  CallState["Ringing"] = "ringing";
  CallState["Ended"] = "ended";
})(CallState || (exports.CallState = CallState = {}));

var CallType;
exports.CallType = CallType;

(function (CallType) {
  CallType["Voice"] = "voice";
  CallType["Video"] = "video";
})(CallType || (exports.CallType = CallType = {}));

var CallDirection;
exports.CallDirection = CallDirection;

(function (CallDirection) {
  CallDirection["Inbound"] = "inbound";
  CallDirection["Outbound"] = "outbound";
})(CallDirection || (exports.CallDirection = CallDirection = {}));

var CallParty;
exports.CallParty = CallParty;

(function (CallParty) {
  CallParty["Local"] = "local";
  CallParty["Remote"] = "remote";
})(CallParty || (exports.CallParty = CallParty = {}));

var CallEvent;
exports.CallEvent = CallEvent;

(function (CallEvent) {
  CallEvent["Hangup"] = "hangup";
  CallEvent["State"] = "state";
  CallEvent["Error"] = "error";
  CallEvent["Replaced"] = "replaced";
  CallEvent["LocalHoldUnhold"] = "local_hold_unhold";
  CallEvent["RemoteHoldUnhold"] = "remote_hold_unhold";
  CallEvent["HoldUnhold"] = "hold_unhold";
})(CallEvent || (exports.CallEvent = CallEvent = {}));

var CallErrorCode;
exports.CallErrorCode = CallErrorCode;

(function (CallErrorCode) {
  CallErrorCode["UserHangup"] = "user_hangup";
  CallErrorCode["LocalOfferFailed"] = "local_offer_failed";
  CallErrorCode["NoUserMedia"] = "no_user_media";
  CallErrorCode["UnknownDevices"] = "unknown_devices";
  CallErrorCode["SendInvite"] = "send_invite";
  CallErrorCode["CreateAnswer"] = "create_answer";
  CallErrorCode["SendAnswer"] = "send_answer";
  CallErrorCode["SetRemoteDescription"] = "set_remote_description";
  CallErrorCode["SetLocalDescription"] = "set_local_description";
  CallErrorCode["AnsweredElsewhere"] = "answered_elsewhere";
  CallErrorCode["IceFailed"] = "ice_failed";
  CallErrorCode["InviteTimeout"] = "invite_timeout";
  CallErrorCode["Replaced"] = "replaced";
  CallErrorCode["SignallingFailed"] = "signalling_timeout";
})(CallErrorCode || (exports.CallErrorCode = CallErrorCode = {}));

var ConstraintsType;
/**
 * The version field that we set in m.call.* events
 */

(function (ConstraintsType) {
  ConstraintsType["Audio"] = "audio";
  ConstraintsType["Video"] = "video";
})(ConstraintsType || (ConstraintsType = {}));

var VOIP_PROTO_VERSION = 1;
/** The fallback ICE server to use for STUN or TURN protocols. */

var FALLBACK_ICE_SERVER = 'stun:turn.matrix.org';
/** The length of time a call can be ringing for. */

var CALL_TIMEOUT_MS = 60000;
/** Retrieves sources from desktopCapturer */

function getDesktopCapturerSources() {
  var options = {
    thumbnailSize: {
      height: 176,
      width: 312
    },
    types: ["screen", "window"]
  };
  return window.electron.getDesktopCapturerSources(options);
}

var CallError = /*#__PURE__*/function (_Error) {
  (0, _inherits2["default"])(CallError, _Error);

  var _super = _createSuper(CallError);

  function CallError(code, msg, err) {
    var _this;

    (0, _classCallCheck2["default"])(this, CallError);
    // Stil ldon't think there's any way to have proper nested errors
    _this = _super.call(this, msg + ": " + err);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "code", void 0);
    _this.code = code;
    return _this;
  }

  return (0, _createClass2["default"])(CallError);
}( /*#__PURE__*/(0, _wrapNativeSuper2["default"])(Error));

exports.CallError = CallError;

function genCallID() {
  return Date.now().toString() + (0, _randomstring.randomString)(16);
}
/**
 * Construct a new Matrix Call.
 * @constructor
 * @param {Object} opts Config options.
 * @param {string} opts.roomId The room ID for this call.
 * @param {Object} opts.webRtc The WebRTC globals from the browser.
 * @param {boolean} opts.forceTURN whether relay through TURN should be forced.
 * @param {Object} opts.URL The URL global.
 * @param {Array<Object>} opts.turnServers Optional. A list of TURN servers.
 * @param {MatrixClient} opts.client The Matrix Client instance to send events to.
 */


var MatrixCall = /*#__PURE__*/function (_EventEmitter) {
  (0, _inherits2["default"])(MatrixCall, _EventEmitter);

  var _super2 = _createSuper(MatrixCall);

  // Fix when client is TSified
  // XXX: I don't know why this is called 'config'.
  // The party ID of the other side: undefined if we haven't chosen a partner
  // yet, null if we have but they didn't send a party ID.
  // in the browser it's 'number'
  // The logic of when & if a call is on hold is nontrivial and explained in is*OnHold
  // This flag represents whether we want the other party to be on hold
  // and this one we set when we're transitioning out of the hold state because we
  // can't tell the difference between that and the other party holding us
  // the stats for the call at the point it ended. We can't get these after we
  // tear the call down, so we just grab a snapshot before we stop the call.
  // The typescript definitions have this type as 'any' :(
  // Perfect negotiation state: https://www.w3.org/TR/webrtc/#perfect-negotiation-example
  // If candidates arrive before we've picked an opponent (which, in particular,
  // will happen if the opponent sends candidates eagerly before the user answers
  // the call) we buffer them up here so we can then add the ones from the party we pick
  function MatrixCall(opts) {
    var _this2;

    (0, _classCallCheck2["default"])(this, MatrixCall);
    _this2 = _super2.call(this);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "roomId", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "type", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "callId", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "state", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "hangupParty", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "hangupReason", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "direction", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "ourPartyId", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "client", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "forceTURN", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "turnServers", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "candidateSendQueue", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "candidateSendTries", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "sentEndOfCandidates", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "peerConn", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "localVideoElement", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "remoteVideoElement", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "remoteAudioElement", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "screenSharingStream", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "remoteStream", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "localAVStream", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "inviteOrAnswerSent", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "waitForLocalAVStream", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "config", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "successor", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "opponentMember", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "opponentVersion", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "opponentPartyId", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "opponentCaps", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "inviteTimeout", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "remoteOnHold", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "unholdingRemote", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "micMuted", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "vidMuted", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "callStatsAtEnd", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "makingOffer", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "ignoreOffer", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "remoteCandidateBuffer", new Map());
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "gotUserMediaForInvite", /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(stream) {
        var videoEl, _iterator, _step, audioTrack, _iterator2, _step2, videoTrack;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!_this2.successor) {
                  _context.next = 3;
                  break;
                }

                _this2.successor.gotUserMediaForAnswer(stream);

                return _context.abrupt("return");

              case 3:
                if (!_this2.callHasEnded()) {
                  _context.next = 6;
                  break;
                }

                _this2.stopAllMedia();

                return _context.abrupt("return");

              case 6:
                _this2.localAVStream = stream;

                _logger.logger.info("Got local AV stream with id " + _this2.localAVStream.id);

                _this2.setState(CallState.CreateOffer);

                _logger.logger.debug("gotUserMediaForInvite -> " + _this2.type);

                videoEl = _this2.getLocalVideoElement();

                if (!(videoEl && _this2.type === CallType.Video)) {
                  _context.next = 23;
                  break;
                }

                videoEl.autoplay = true;

                if (_this2.screenSharingStream) {
                  _logger.logger.debug("Setting screen sharing stream to the local video element");

                  videoEl.srcObject = _this2.screenSharingStream;
                } else {
                  videoEl.srcObject = stream;
                }

                videoEl.muted = true;
                _context.prev = 15;
                _context.next = 18;
                return videoEl.play();

              case 18:
                _context.next = 23;
                break;

              case 20:
                _context.prev = 20;
                _context.t0 = _context["catch"](15);

                _logger.logger.info("Failed to play local video element", _context.t0);

              case 23:
                // why do we enable audio (and only audio) tracks here? -- matthew
                setTracksEnabled(stream.getAudioTracks(), true);
                _iterator = _createForOfIteratorHelper(stream.getAudioTracks());

                try {
                  for (_iterator.s(); !(_step = _iterator.n()).done;) {
                    audioTrack = _step.value;

                    _logger.logger.info("Adding audio track with id " + audioTrack.id);

                    _this2.peerConn.addTrack(audioTrack, stream);
                  }
                } catch (err) {
                  _iterator.e(err);
                } finally {
                  _iterator.f();
                }

                _iterator2 = _createForOfIteratorHelper((_this2.screenSharingStream || stream).getVideoTracks());

                try {
                  for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                    videoTrack = _step2.value;

                    _logger.logger.info("Adding video track with id " + videoTrack.id);

                    _this2.peerConn.addTrack(videoTrack, stream);
                  } // Now we wait for the negotiationneeded event

                } catch (err) {
                  _iterator2.e(err);
                } finally {
                  _iterator2.f();
                }

              case 28:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[15, 20]]);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "gotUserMediaForAnswer", /*#__PURE__*/function () {
      var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(stream) {
        var localVidEl, _iterator3, _step3, track, myAnswer;

        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!_this2.callHasEnded()) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt("return");

              case 2:
                localVidEl = _this2.getLocalVideoElement();

                if (!(localVidEl && _this2.type === CallType.Video)) {
                  _context2.next = 15;
                  break;
                }

                localVidEl.autoplay = true;
                localVidEl.srcObject = stream;
                localVidEl.muted = true;
                _context2.prev = 7;
                _context2.next = 10;
                return localVidEl.play();

              case 10:
                _context2.next = 15;
                break;

              case 12:
                _context2.prev = 12;
                _context2.t0 = _context2["catch"](7);

                _logger.logger.info("Failed to play local video element", _context2.t0);

              case 15:
                _this2.localAVStream = stream;

                _logger.logger.info("Got local AV stream with id " + _this2.localAVStream.id);

                setTracksEnabled(stream.getAudioTracks(), true);
                _iterator3 = _createForOfIteratorHelper(stream.getTracks());

                try {
                  for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
                    track = _step3.value;

                    _this2.peerConn.addTrack(track, stream);
                  }
                } catch (err) {
                  _iterator3.e(err);
                } finally {
                  _iterator3.f();
                }

                _this2.setState(CallState.CreateAnswer);

                _context2.prev = 21;
                _context2.next = 24;
                return _this2.peerConn.createAnswer();

              case 24:
                myAnswer = _context2.sent;
                _context2.next = 32;
                break;

              case 27:
                _context2.prev = 27;
                _context2.t1 = _context2["catch"](21);

                _logger.logger.debug("Failed to create answer: ", _context2.t1);

                _this2.terminate(CallParty.Local, CallErrorCode.CreateAnswer, true);

                return _context2.abrupt("return");

              case 32:
                _context2.prev = 32;
                _context2.next = 35;
                return _this2.peerConn.setLocalDescription(myAnswer);

              case 35:
                _this2.setState(CallState.Connecting); // Allow a short time for initial candidates to be gathered


                _context2.next = 38;
                return new Promise(function (resolve) {
                  setTimeout(resolve, 200);
                });

              case 38:
                _this2.sendAnswer();

                _context2.next = 46;
                break;

              case 41:
                _context2.prev = 41;
                _context2.t2 = _context2["catch"](32);

                _logger.logger.debug("Error setting local description!", _context2.t2);

                _this2.terminate(CallParty.Local, CallErrorCode.SetLocalDescription, true);

                return _context2.abrupt("return");

              case 46:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, null, [[7, 12], [21, 27], [32, 41]]);
      }));

      return function (_x2) {
        return _ref2.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "gotLocalIceCandidate", function (event) {
      if (event.candidate) {
        _logger.logger.debug("Call " + _this2.callId + " got local ICE " + event.candidate.sdpMid + " candidate: " + event.candidate.candidate);

        if (_this2.callHasEnded()) return; // As with the offer, note we need to make a copy of this object, not
        // pass the original: that broke in Chrome ~m43.

        if (event.candidate.candidate !== '' || !_this2.sentEndOfCandidates) {
          _this2.queueCandidate(event.candidate);

          if (event.candidate.candidate === '') _this2.sentEndOfCandidates = true;
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onIceGatheringStateChange", function (event) {
      _logger.logger.debug("ice gathering state changed to " + _this2.peerConn.iceGatheringState);

      if (_this2.peerConn.iceGatheringState === 'complete' && !_this2.sentEndOfCandidates) {
        // If we didn't get an empty-string candidate to signal the end of candidates,
        // create one ourselves now gathering has finished.
        // We cast because the interface lists all the properties as required but we
        // only want to send 'candidate'
        // XXX: We probably want to send either sdpMid or sdpMLineIndex, as it's not strictly
        // correct to have a candidate that lacks both of these. We'd have to figure out what
        // previous candidates had been sent with and copy them.
        var c = {
          candidate: ''
        };

        _this2.queueCandidate(c);

        _this2.sentEndOfCandidates = true;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "gotLocalOffer", /*#__PURE__*/function () {
      var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(description) {
        var eventType, content, code, message;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _logger.logger.debug("Created offer: ", description);

                if (!_this2.callHasEnded()) {
                  _context3.next = 4;
                  break;
                }

                _logger.logger.debug("Ignoring newly created offer on call ID " + _this2.callId + " because the call has ended");

                return _context3.abrupt("return");

              case 4:
                _context3.prev = 4;
                _context3.next = 7;
                return _this2.peerConn.setLocalDescription(description);

              case 7:
                _context3.next = 14;
                break;

              case 9:
                _context3.prev = 9;
                _context3.t0 = _context3["catch"](4);

                _logger.logger.debug("Error setting local description!", _context3.t0);

                _this2.terminate(CallParty.Local, CallErrorCode.SetLocalDescription, true);

                return _context3.abrupt("return");

              case 14:
                if (!(_this2.peerConn.iceGatheringState === 'gathering')) {
                  _context3.next = 17;
                  break;
                }

                _context3.next = 17;
                return new Promise(function (resolve) {
                  setTimeout(resolve, 200);
                });

              case 17:
                if (!_this2.callHasEnded()) {
                  _context3.next = 19;
                  break;
                }

                return _context3.abrupt("return");

              case 19:
                eventType = _this2.state === CallState.CreateOffer ? _event.EventType.CallInvite : _event.EventType.CallNegotiate;
                content = {
                  lifetime: CALL_TIMEOUT_MS
                }; // clunky because TypeScript can't folow the types through if we use an expression as the key

                if (_this2.state === CallState.CreateOffer) {
                  content.offer = _this2.peerConn.localDescription;
                } else {
                  content.description = _this2.peerConn.localDescription;
                }

                if (_this2.client._supportsCallTransfer) {
                  content.capabilities = {
                    'm.call.transferee': true
                  };
                } // Get rid of any candidates waiting to be sent: they'll be included in the local
                // description we just got and will send in the offer.


                _logger.logger.info("Discarding ".concat(_this2.candidateSendQueue.length, " candidates that will be sent in offer"));

                _this2.candidateSendQueue = [];
                _context3.prev = 25;
                _context3.next = 28;
                return _this2.sendVoipEvent(eventType, content);

              case 28:
                _context3.next = 41;
                break;

              case 30:
                _context3.prev = 30;
                _context3.t1 = _context3["catch"](25);

                _logger.logger.error("Failed to send invite", _context3.t1);

                if (_context3.t1.event) _this2.client.cancelPendingEvent(_context3.t1.event);
                code = CallErrorCode.SignallingFailed;
                message = "Signalling failed";

                if (_this2.state === CallState.CreateOffer) {
                  code = CallErrorCode.SendInvite;
                  message = "Failed to send invite";
                }

                if (_context3.t1.name == 'UnknownDeviceError') {
                  code = CallErrorCode.UnknownDevices;
                  message = "Unknown devices present in the room";
                }

                _this2.emit(CallEvent.Error, new CallError(code, message, _context3.t1));

                _this2.terminate(CallParty.Local, code, false); // no need to carry on & send the candidate queue, but we also
                // don't want to rethrow the error


                return _context3.abrupt("return");

              case 41:
                _this2.sendCandidateQueue();

                if (_this2.state === CallState.CreateOffer) {
                  _this2.inviteOrAnswerSent = true;

                  _this2.setState(CallState.InviteSent);

                  _this2.inviteTimeout = setTimeout(function () {
                    _this2.inviteTimeout = null;

                    if (_this2.state === CallState.InviteSent) {
                      _this2.hangup(CallErrorCode.InviteTimeout, false);
                    }
                  }, CALL_TIMEOUT_MS);
                }

              case 43:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, null, [[4, 9], [25, 30]]);
      }));

      return function (_x3) {
        return _ref3.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "getLocalOfferFailed", function (err) {
      _logger.logger.error("Failed to get local offer", err);

      _this2.emit(CallEvent.Error, new CallError(CallErrorCode.LocalOfferFailed, "Failed to get local offer!", err));

      _this2.terminate(CallParty.Local, CallErrorCode.LocalOfferFailed, false);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "getUserMediaFailed", function (err) {
      if (_this2.successor) {
        _this2.successor.getUserMediaFailed(err);

        return;
      }

      _logger.logger.warn("Failed to get user media - ending call", err);

      _this2.emit(CallEvent.Error, new CallError(CallErrorCode.NoUserMedia, "Couldn't start capturing media! Is your microphone set up and " + "does this app have permission?", err));

      _this2.terminate(CallParty.Local, CallErrorCode.NoUserMedia, false);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onIceConnectionStateChanged", function () {
      if (_this2.callHasEnded()) {
        return; // because ICE can still complete as we're ending the call
      }

      _logger.logger.debug("Call ID " + _this2.callId + ": ICE connection state changed to: " + _this2.peerConn.iceConnectionState); // ideally we'd consider the call to be connected when we get media but
      // chrome doesn't implement any of the 'onstarted' events yet


      if (_this2.peerConn.iceConnectionState == 'connected') {
        _this2.setState(CallState.Connected);
      } else if (_this2.peerConn.iceConnectionState == 'failed') {
        _this2.hangup(CallErrorCode.IceFailed, false);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onSignallingStateChanged", function () {
      _logger.logger.debug("call " + _this2.callId + ": Signalling state changed to: " + _this2.peerConn.signalingState);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onTrack", function (ev) {
      if (ev.streams.length === 0) {
        _logger.logger.warn("Streamless ".concat(ev.track.kind, " found: ignoring."));

        return;
      } // If we already have a stream, check this track is from the same one


      if (_this2.remoteStream && ev.streams[0].id !== _this2.remoteStream.id) {
        _logger.logger.warn("Ignoring new stream ID ".concat(ev.streams[0].id, ": we already have stream ID ").concat(_this2.remoteStream.id));

        return;
      }

      if (!_this2.remoteStream) {
        _logger.logger.info("Got remote stream with id " + ev.streams[0].id);
      } // Note that we check by ID above and always set the remote stream: Chrome appears
      // to make new stream objects when tranciever directionality is changed and the 'active'
      // status of streams change


      _this2.remoteStream = ev.streams[0];

      _logger.logger.debug("Track id ".concat(ev.track.id, " of kind ").concat(ev.track.kind, " added"));

      if (ev.track.kind === 'video') {
        if (_this2.remoteVideoElement) {
          _this2.playRemoteVideo();
        }
      } else {
        if (_this2.remoteAudioElement) _this2.playRemoteAudio();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onNegotiationNeeded", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
      var myOffer;
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _logger.logger.info("Negotation is needed!");

              if (!(_this2.state !== CallState.CreateOffer && _this2.opponentVersion === 0)) {
                _context4.next = 4;
                break;
              }

              _logger.logger.info("Opponent does not support renegotiation: ignoring negotiationneeded event");

              return _context4.abrupt("return");

            case 4:
              _this2.makingOffer = true;
              _context4.prev = 5;
              _context4.next = 8;
              return _this2.peerConn.createOffer();

            case 8:
              myOffer = _context4.sent;
              _context4.next = 11;
              return _this2.gotLocalOffer(myOffer);

            case 11:
              _context4.next = 17;
              break;

            case 13:
              _context4.prev = 13;
              _context4.t0 = _context4["catch"](5);

              _this2.getLocalOfferFailed(_context4.t0);

              return _context4.abrupt("return");

            case 17:
              _context4.prev = 17;
              _this2.makingOffer = false;
              return _context4.finish(17);

            case 20:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, null, [[5, 13, 17, 20]]);
    })));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onHangupReceived", function (msg) {
      _logger.logger.debug("Hangup received for call ID " + _this2.callId); // party ID must match (our chosen partner hanging up the call) or be undefined (we haven't chosen
      // a partner yet but we're treating the hangup as a reject as per VoIP v0)


      if (_this2.partyIdMatches(msg) || _this2.state === CallState.Ringing) {
        // default reason is user_hangup
        _this2.terminate(CallParty.Remote, msg.reason || CallErrorCode.UserHangup, true);
      } else {
        _logger.logger.info("Ignoring message from party ID ".concat(msg.party_id, ": our partner is ").concat(_this2.opponentPartyId));
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onRejectReceived", function (msg) {
      _logger.logger.debug("Reject received for call ID " + _this2.callId); // No need to check party_id for reject because if we'd received either
      // an answer or reject, we wouldn't be in state InviteSent


      var shouldTerminate = // reject events also end the call if it's ringing: it's another of
      // our devices rejecting the call.
      [CallState.InviteSent, CallState.Ringing].includes(_this2.state) || // also if we're in the init state and it's an inbound call, since
      // this means we just haven't entered the ringing state yet
      _this2.state === CallState.Fledgling && _this2.direction === CallDirection.Inbound;

      if (shouldTerminate) {
        _this2.terminate(CallParty.Remote, CallErrorCode.UserHangup, true);
      } else {
        _logger.logger.debug("Call is in state: ".concat(_this2.state, ": ignoring reject"));
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onAnsweredElsewhere", function (msg) {
      _logger.logger.debug("Call ID " + _this2.callId + " answered elsewhere");

      _this2.terminate(CallParty.Remote, CallErrorCode.AnsweredElsewhere, true);
    });
    _this2.roomId = opts.roomId;
    _this2.client = opts.client;
    _this2.type = null;
    _this2.forceTURN = opts.forceTURN;
    _this2.ourPartyId = _this2.client.deviceId; // Array of Objects with urls, username, credential keys

    _this2.turnServers = opts.turnServers || [];

    if (_this2.turnServers.length === 0 && _this2.client.isFallbackICEServerAllowed()) {
      _this2.turnServers.push({
        urls: [FALLBACK_ICE_SERVER]
      });
    }

    var _iterator4 = _createForOfIteratorHelper(_this2.turnServers),
        _step4;

    try {
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        var server = _step4.value;
        utils.checkObjectHasKeys(server, ["urls"]);
      }
    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }

    _this2.callId = genCallID();
    _this2.state = CallState.Fledgling; // A queue for candidates waiting to go out.
    // We try to amalgamate candidates into a single candidate message where
    // possible

    _this2.candidateSendQueue = [];
    _this2.candidateSendTries = 0;
    _this2.sentEndOfCandidates = false;
    _this2.inviteOrAnswerSent = false;
    _this2.makingOffer = false;
    _this2.remoteOnHold = false;
    _this2.unholdingRemote = false;
    _this2.micMuted = false;
    _this2.vidMuted = false;
    return _this2;
  }
  /**
   * Place a voice call to this room.
   * @throws If you have not specified a listener for 'error' events.
   */


  (0, _createClass2["default"])(MatrixCall, [{
    key: "placeVoiceCall",
    value: function () {
      var _placeVoiceCall = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
        var constraints;
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _logger.logger.debug("placeVoiceCall");

                this.checkForErrorListener();
                constraints = getUserMediaContraints(ConstraintsType.Audio);
                this.type = CallType.Voice;
                _context5.next = 6;
                return this.placeCallWithConstraints(constraints);

              case 6:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function placeVoiceCall() {
        return _placeVoiceCall.apply(this, arguments);
      }

      return placeVoiceCall;
    }()
    /**
     * Place a video call to this room.
     * @param {Element} remoteVideoElement a <code>&lt;video&gt;</code> DOM element
     * to render video to.
     * @param {Element} localVideoElement a <code>&lt;video&gt;</code> DOM element
     * to render the local camera preview.
     * @throws If you have not specified a listener for 'error' events.
     */

  }, {
    key: "placeVideoCall",
    value: function () {
      var _placeVideoCall = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(remoteVideoElement, localVideoElement) {
        var constraints;
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _logger.logger.debug("placeVideoCall");

                this.checkForErrorListener();
                this.localVideoElement = localVideoElement;
                this.remoteVideoElement = remoteVideoElement;
                constraints = getUserMediaContraints(ConstraintsType.Video);
                this.type = CallType.Video;
                _context6.next = 8;
                return this.placeCallWithConstraints(constraints);

              case 8:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function placeVideoCall(_x4, _x5) {
        return _placeVideoCall.apply(this, arguments);
      }

      return placeVideoCall;
    }()
    /**
     * Place a screen-sharing call to this room. This includes audio.
     * <b>This method is EXPERIMENTAL and subject to change without warning. It
     * only works in Google Chrome and Firefox >= 44.</b>
     * @param {Element} remoteVideoElement a <code>&lt;video&gt;</code> DOM element
     * to render video to.
     * @param {Element} localVideoElement a <code>&lt;video&gt;</code> DOM element
     * to render the local camera preview.
     * @throws If you have not specified a listener for 'error' events.
     */

  }, {
    key: "placeScreenSharingCall",
    value: function () {
      var _placeScreenSharingCall = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(remoteVideoElement, localVideoElement, selectDesktopCapturerSource) {
        var _window$electron, screenshareConstraints, audioConstraints;

        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _logger.logger.debug("placeScreenSharingCall");

                this.checkForErrorListener();
                this.localVideoElement = localVideoElement;
                this.remoteVideoElement = remoteVideoElement;
                _context7.prev = 4;
                _context7.next = 7;
                return getScreenshareContraints(selectDesktopCapturerSource);

              case 7:
                screenshareConstraints = _context7.sent;

                if (screenshareConstraints) {
                  _context7.next = 11;
                  break;
                }

                this.terminate(CallParty.Local, CallErrorCode.NoUserMedia, false);
                return _context7.abrupt("return");

              case 11:
                if (!((_window$electron = window.electron) !== null && _window$electron !== void 0 && _window$electron.getDesktopCapturerSources)) {
                  _context7.next = 18;
                  break;
                }

                // We are using Electron
                _logger.logger.debug("Getting screen stream using getUserMedia()...");

                _context7.next = 15;
                return navigator.mediaDevices.getUserMedia(screenshareConstraints);

              case 15:
                this.screenSharingStream = _context7.sent;
                _context7.next = 22;
                break;

              case 18:
                // We are not using Electron
                _logger.logger.debug("Getting screen stream using getDisplayMedia()...");

                _context7.next = 21;
                return navigator.mediaDevices.getDisplayMedia(screenshareConstraints);

              case 21:
                this.screenSharingStream = _context7.sent;

              case 22:
                _logger.logger.debug("Got screen stream, requesting audio stream...");

                audioConstraints = getUserMediaContraints(ConstraintsType.Audio);
                this.placeCallWithConstraints(audioConstraints);
                _context7.next = 31;
                break;

              case 27:
                _context7.prev = 27;
                _context7.t0 = _context7["catch"](4);
                this.emit(CallEvent.Error, new CallError(CallErrorCode.NoUserMedia, "Failed to get screen-sharing stream: ", _context7.t0));
                this.terminate(CallParty.Local, CallErrorCode.NoUserMedia, false);

              case 31:
                this.type = CallType.Video;

              case 32:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this, [[4, 27]]);
      }));

      function placeScreenSharingCall(_x6, _x7, _x8) {
        return _placeScreenSharingCall.apply(this, arguments);
      }

      return placeScreenSharingCall;
    }()
  }, {
    key: "getOpponentMember",
    value: function getOpponentMember() {
      return this.opponentMember;
    }
  }, {
    key: "opponentCanBeTransferred",
    value: function opponentCanBeTransferred() {
      return Boolean(this.opponentCaps && this.opponentCaps["m.call.transferee"]);
    }
    /**
     * Retrieve the local <code>&lt;video&gt;</code> DOM element.
     * @return {Element} The dom element
     */

  }, {
    key: "getLocalVideoElement",
    value: function getLocalVideoElement() {
      return this.localVideoElement;
    }
    /**
     * Retrieve the remote <code>&lt;video&gt;</code> DOM element
     * used for playing back video capable streams.
     * @return {Element} The dom element
     */

  }, {
    key: "getRemoteVideoElement",
    value: function getRemoteVideoElement() {
      return this.remoteVideoElement;
    }
    /**
     * Retrieve the remote <code>&lt;audio&gt;</code> DOM element
     * used for playing back audio only streams.
     * @return {Element} The dom element
     */

  }, {
    key: "getRemoteAudioElement",
    value: function getRemoteAudioElement() {
      return this.remoteAudioElement;
    }
    /**
     * Set the local <code>&lt;video&gt;</code> DOM element. If this call is active,
     * video will be rendered to it immediately.
     * @param {Element} element The <code>&lt;video&gt;</code> DOM element.
     */

  }, {
    key: "setLocalVideoElement",
    value: function () {
      var _setLocalVideoElement = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(element) {
        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                this.localVideoElement = element;

                if (!(element && this.localAVStream && this.type === CallType.Video)) {
                  _context8.next = 13;
                  break;
                }

                element.autoplay = true;
                element.srcObject = this.localAVStream;
                element.muted = true;
                _context8.prev = 5;
                _context8.next = 8;
                return element.play();

              case 8:
                _context8.next = 13;
                break;

              case 10:
                _context8.prev = 10;
                _context8.t0 = _context8["catch"](5);

                _logger.logger.info("Failed to play local video element", _context8.t0);

              case 13:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this, [[5, 10]]);
      }));

      function setLocalVideoElement(_x9) {
        return _setLocalVideoElement.apply(this, arguments);
      }

      return setLocalVideoElement;
    }()
    /**
     * Set the remote <code>&lt;video&gt;</code> DOM element. If this call is active,
     * the first received video-capable stream will be rendered to it immediately.
     * @param {Element} element The <code>&lt;video&gt;</code> DOM element.
     */

  }, {
    key: "setRemoteVideoElement",
    value: function setRemoteVideoElement(element) {
      if (element === this.remoteVideoElement) return;
      element.autoplay = true; // if we already have an audio element set, use that instead and mute the audio
      // on this video element.

      if (this.remoteAudioElement) element.muted = true;
      this.remoteVideoElement = element;

      if (this.remoteStream) {
        this.playRemoteVideo();
      }
    }
    /**
     * Set the remote <code>&lt;audio&gt;</code> DOM element. If this call is active,
     * the first received audio-only stream will be rendered to it immediately.
     * The audio will *not* be rendered from the remoteVideoElement.
     * @param {Element} element The <code>&lt;video&gt;</code> DOM element.
     */

  }, {
    key: "setRemoteAudioElement",
    value: function () {
      var _setRemoteAudioElement = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(element) {
        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                if (!(element === this.remoteAudioElement)) {
                  _context9.next = 2;
                  break;
                }

                return _context9.abrupt("return");

              case 2:
                this.remoteAudioElement = element;
                if (this.remoteStream) this.playRemoteAudio();

              case 4:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function setRemoteAudioElement(_x10) {
        return _setRemoteAudioElement.apply(this, arguments);
      }

      return setRemoteAudioElement;
    }() // The typescript definitions have this type as 'any' :(

  }, {
    key: "getCurrentCallStats",
    value: function () {
      var _getCurrentCallStats = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10() {
        return _regenerator["default"].wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                if (!this.callHasEnded()) {
                  _context10.next = 2;
                  break;
                }

                return _context10.abrupt("return", this.callStatsAtEnd);

              case 2:
                return _context10.abrupt("return", this.collectCallStats());

              case 3:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function getCurrentCallStats() {
        return _getCurrentCallStats.apply(this, arguments);
      }

      return getCurrentCallStats;
    }()
  }, {
    key: "collectCallStats",
    value: function () {
      var _collectCallStats = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11() {
        var statsReport, stats, _iterator5, _step5, item;

        return _regenerator["default"].wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                if (this.peerConn) {
                  _context11.next = 2;
                  break;
                }

                return _context11.abrupt("return");

              case 2:
                _context11.next = 4;
                return this.peerConn.getStats();

              case 4:
                statsReport = _context11.sent;
                stats = [];
                _iterator5 = _createForOfIteratorHelper(statsReport);

                try {
                  for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
                    item = _step5.value;
                    stats.push(item[1]);
                  }
                } catch (err) {
                  _iterator5.e(err);
                } finally {
                  _iterator5.f();
                }

                return _context11.abrupt("return", stats);

              case 9:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function collectCallStats() {
        return _collectCallStats.apply(this, arguments);
      }

      return collectCallStats;
    }()
    /**
     * Configure this call from an invite event. Used by MatrixClient.
     * @param {MatrixEvent} event The m.call.invite event
     */

  }, {
    key: "initWithInvite",
    value: function () {
      var _initWithInvite = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12(event) {
        var _this3 = this;

        var invite, haveTurnCreds;
        return _regenerator["default"].wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                invite = event.getContent();
                this.direction = CallDirection.Inbound; // make sure we have valid turn creds. Unless something's gone wrong, it should
                // poll and keep the credentials valid so this should be instant.

                _context12.next = 4;
                return this.client._checkTurnServers();

              case 4:
                haveTurnCreds = _context12.sent;

                if (!haveTurnCreds) {
                  _logger.logger.warn("Failed to get TURN credentials! Proceeding with call anyway...");
                }

                this.peerConn = this.createPeerConnection(); // we must set the party ID before await-ing on anything: the call event
                // handler will start giving us more call events (eg. candidates) so if
                // we haven't set the party ID, we'll ignore them.

                this.chooseOpponent(event);
                _context12.prev = 8;
                _context12.next = 11;
                return this.peerConn.setRemoteDescription(invite.offer);

              case 11:
                _context12.next = 13;
                return this.addBufferedIceCandidates();

              case 13:
                _context12.next = 20;
                break;

              case 15:
                _context12.prev = 15;
                _context12.t0 = _context12["catch"](8);

                _logger.logger.debug("Failed to set remote description", _context12.t0);

                this.terminate(CallParty.Local, CallErrorCode.SetRemoteDescription, false);
                return _context12.abrupt("return");

              case 20:
                if (!(!this.remoteStream || this.remoteStream.getTracks().length === 0)) {
                  _context12.next = 24;
                  break;
                }

                _logger.logger.error("No remote stream or no tracks after setting remote description!");

                this.terminate(CallParty.Local, CallErrorCode.SetRemoteDescription, false);
                return _context12.abrupt("return");

              case 24:
                this.type = this.remoteStream.getTracks().some(function (t) {
                  return t.kind === 'video';
                }) ? CallType.Video : CallType.Voice;
                this.setState(CallState.Ringing);

                if (event.getLocalAge()) {
                  setTimeout(function () {
                    if (_this3.state == CallState.Ringing) {
                      _logger.logger.debug("Call invite has expired. Hanging up.");

                      _this3.hangupParty = CallParty.Remote; // effectively

                      _this3.setState(CallState.Ended);

                      _this3.stopAllMedia();

                      if (_this3.peerConn.signalingState != 'closed') {
                        _this3.peerConn.close();
                      }

                      _this3.emit(CallEvent.Hangup);
                    }
                  }, invite.lifetime - event.getLocalAge());
                }

              case 27:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this, [[8, 15]]);
      }));

      function initWithInvite(_x11) {
        return _initWithInvite.apply(this, arguments);
      }

      return initWithInvite;
    }()
    /**
     * Configure this call from a hangup or reject event. Used by MatrixClient.
     * @param {MatrixEvent} event The m.call.hangup event
     */

  }, {
    key: "initWithHangup",
    value: function initWithHangup(event) {
      // perverse as it may seem, sometimes we want to instantiate a call with a
      // hangup message (because when getting the state of the room on load, events
      // come in reverse order and we want to remember that a call has been hung up)
      this.setState(CallState.Ended);
    }
    /**
     * Answer a call.
     */

  }, {
    key: "answer",
    value: function () {
      var _answer = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13() {
        var constraints, mediaStream;
        return _regenerator["default"].wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                if (!this.inviteOrAnswerSent) {
                  _context13.next = 2;
                  break;
                }

                return _context13.abrupt("return");

              case 2:
                _logger.logger.debug("Answering call ".concat(this.callId, " of type ").concat(this.type));

                if (!(!this.localAVStream && !this.waitForLocalAVStream)) {
                  _context13.next = 22;
                  break;
                }

                constraints = getUserMediaContraints(this.type == CallType.Video ? ConstraintsType.Video : ConstraintsType.Audio);

                _logger.logger.log("Getting user media with constraints", constraints);

                this.setState(CallState.WaitLocalMedia);
                this.waitForLocalAVStream = true;
                _context13.prev = 8;
                _context13.next = 11;
                return navigator.mediaDevices.getUserMedia(constraints);

              case 11:
                mediaStream = _context13.sent;
                this.waitForLocalAVStream = false;
                this.gotUserMediaForAnswer(mediaStream);
                _context13.next = 20;
                break;

              case 16:
                _context13.prev = 16;
                _context13.t0 = _context13["catch"](8);
                this.getUserMediaFailed(_context13.t0);
                return _context13.abrupt("return");

              case 20:
                _context13.next = 23;
                break;

              case 22:
                if (this.localAVStream) {
                  this.gotUserMediaForAnswer(this.localAVStream);
                } else if (this.waitForLocalAVStream) {
                  this.setState(CallState.WaitLocalMedia);
                }

              case 23:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, this, [[8, 16]]);
      }));

      function answer() {
        return _answer.apply(this, arguments);
      }

      return answer;
    }()
    /**
     * Replace this call with a new call, e.g. for glare resolution. Used by
     * MatrixClient.
     * @param {MatrixCall} newCall The new call.
     */

  }, {
    key: "replacedBy",
    value: function replacedBy(newCall) {
      _logger.logger.debug(this.callId + " being replaced by " + newCall.callId);

      if (this.state === CallState.WaitLocalMedia) {
        _logger.logger.debug("Telling new call to wait for local media");

        newCall.waitForLocalAVStream = true;
      } else if (this.state === CallState.CreateOffer) {
        _logger.logger.debug("Handing local stream to new call");

        newCall.gotUserMediaForAnswer(this.localAVStream);
        delete this.localAVStream;
      } else if (this.state === CallState.InviteSent) {
        _logger.logger.debug("Handing local stream to new call");

        newCall.gotUserMediaForAnswer(this.localAVStream);
        delete this.localAVStream;
      }

      newCall.localVideoElement = this.localVideoElement;
      newCall.remoteVideoElement = this.remoteVideoElement;
      newCall.remoteAudioElement = this.remoteAudioElement;
      this.successor = newCall;
      this.emit(CallEvent.Replaced, newCall);
      this.hangup(CallErrorCode.Replaced, true);
    }
    /**
     * Hangup a call.
     * @param {string} reason The reason why the call is being hung up.
     * @param {boolean} suppressEvent True to suppress emitting an event.
     */

  }, {
    key: "hangup",
    value: function hangup(reason, suppressEvent) {
      if (this.callHasEnded()) return;

      _logger.logger.debug("Ending call " + this.callId);

      this.terminate(CallParty.Local, reason, !suppressEvent); // We don't want to send hangup here if we didn't even get to sending an invite

      if (this.state === CallState.WaitLocalMedia) return;
      var content = {}; // Continue to send no reason for user hangups temporarily, until
      // clients understand the user_hangup reason (voip v1)

      if (reason !== CallErrorCode.UserHangup) content['reason'] = reason;
      this.sendVoipEvent(_event.EventType.CallHangup, {});
    }
    /**
     * Reject a call
     * This used to be done by calling hangup, but is a separate method and protocol
     * event as of MSC2746.
     */

  }, {
    key: "reject",
    value: function reject() {
      if (this.state !== CallState.Ringing) {
        throw Error("Call must be in 'ringing' state to reject!");
      }

      if (this.opponentVersion < 1) {
        _logger.logger.info("Opponent version is less than 1 (".concat(this.opponentVersion, "): sending hangup instead of reject"));

        this.hangup(CallErrorCode.UserHangup, true);
        return;
      }

      _logger.logger.debug("Rejecting call: " + this.callId);

      this.terminate(CallParty.Local, CallErrorCode.UserHangup, true);
      this.sendVoipEvent(_event.EventType.CallReject, {});
    }
    /**
     * Set whether our outbound video should be muted or not.
     * @param {boolean} muted True to mute the outbound video.
     */

  }, {
    key: "setLocalVideoMuted",
    value: function setLocalVideoMuted(muted) {
      this.vidMuted = muted;
      this.updateMuteStatus();
    }
    /**
     * Check if local video is muted.
     *
     * If there are multiple video tracks, <i>all</i> of the tracks need to be muted
     * for this to return true. This means if there are no video tracks, this will
     * return true.
     * @return {Boolean} True if the local preview video is muted, else false
     * (including if the call is not set up yet).
     */

  }, {
    key: "isLocalVideoMuted",
    value: function isLocalVideoMuted() {
      return this.vidMuted;
    }
    /**
     * Set whether the microphone should be muted or not.
     * @param {boolean} muted True to mute the mic.
     */

  }, {
    key: "setMicrophoneMuted",
    value: function setMicrophoneMuted(muted) {
      this.micMuted = muted;
      this.updateMuteStatus();
    }
    /**
     * Check if the microphone is muted.
     *
     * If there are multiple audio tracks, <i>all</i> of the tracks need to be muted
     * for this to return true. This means if there are no audio tracks, this will
     * return true.
     * @return {Boolean} True if the mic is muted, else false (including if the call
     * is not set up yet).
     */

  }, {
    key: "isMicrophoneMuted",
    value: function isMicrophoneMuted() {
      return this.micMuted;
    }
    /**
     * @returns true if we have put the party on the other side of the call on hold
     * (that is, we are signalling to them that we are not listening)
     */

  }, {
    key: "isRemoteOnHold",
    value: function isRemoteOnHold() {
      return this.remoteOnHold;
    }
  }, {
    key: "setRemoteOnHold",
    value: function setRemoteOnHold(onHold) {
      if (this.isRemoteOnHold() === onHold) return;
      this.remoteOnHold = onHold;
      if (!onHold) this.unholdingRemote = true;

      var _iterator6 = _createForOfIteratorHelper(this.peerConn.getTransceivers()),
          _step6;

      try {
        for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
          var tranceiver = _step6.value;
          // We set 'inactive' rather than 'sendonly' because we're not planning on
          // playing music etc. to the other side.
          tranceiver.direction = onHold ? 'inactive' : 'sendrecv';
        }
      } catch (err) {
        _iterator6.e(err);
      } finally {
        _iterator6.f();
      }

      this.updateMuteStatus();

      if (!onHold) {
        this.playRemoteAudio();
      }

      this.emit(CallEvent.RemoteHoldUnhold, this.remoteOnHold);
    }
    /**
     * Indicates whether we are 'on hold' to the remote party (ie. if true,
     * they cannot hear us). Note that this will return true when we put the
     * remote on hold too due to the way hold is implemented (since we don't
     * wish to play hold music when we put a call on hold, we use 'inactive'
     * rather than 'sendonly')
     * @returns true if the other party has put us on hold
     */

  }, {
    key: "isLocalOnHold",
    value: function isLocalOnHold() {
      if (this.state !== CallState.Connected) return false;
      if (this.unholdingRemote) return false;
      var callOnHold = true; // We consider a call to be on hold only if *all* the tracks are on hold
      // (is this the right thing to do?)

      var _iterator7 = _createForOfIteratorHelper(this.peerConn.getTransceivers()),
          _step7;

      try {
        for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
          var tranceiver = _step7.value;
          var trackOnHold = ['inactive', 'recvonly'].includes(tranceiver.currentDirection);
          if (!trackOnHold) callOnHold = false;
        }
      } catch (err) {
        _iterator7.e(err);
      } finally {
        _iterator7.f();
      }

      return callOnHold;
    }
    /**
     * Sends a DTMF digit to the other party
     * @param digit The digit (nb. string - '#' and '*' are dtmf too)
     */

  }, {
    key: "sendDtmfDigit",
    value: function sendDtmfDigit(digit) {
      var _iterator8 = _createForOfIteratorHelper(this.peerConn.getSenders()),
          _step8;

      try {
        for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
          var sender = _step8.value;

          if (sender.track.kind === 'audio' && sender.dtmf) {
            sender.dtmf.insertDTMF(digit);
            return;
          }
        }
      } catch (err) {
        _iterator8.e(err);
      } finally {
        _iterator8.f();
      }

      throw new Error("Unable to find a track to send DTMF on");
    }
  }, {
    key: "updateMuteStatus",
    value: function updateMuteStatus() {
      if (!this.localAVStream) {
        return;
      }

      var micShouldBeMuted = this.micMuted || this.remoteOnHold;
      setTracksEnabled(this.localAVStream.getAudioTracks(), !micShouldBeMuted);
      var vidShouldBeMuted = this.vidMuted || this.remoteOnHold;
      setTracksEnabled(this.localAVStream.getVideoTracks(), !vidShouldBeMuted);

      if (this.remoteOnHold) {
        if (this.remoteAudioElement && this.remoteAudioElement.srcObject === this.remoteStream) {
          this.remoteAudioElement.muted = true;
        } else if (this.remoteVideoElement && this.remoteVideoElement.srcObject === this.remoteStream) {
          this.remoteVideoElement.muted = true;
        }
      } else {
        this.playRemoteAudio();
      }
    }
    /**
     * Internal
     * @param {Object} stream
     */

  }, {
    key: "sendAnswer",
    value: function () {
      var _sendAnswer = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14() {
        var answerContent, code, message;
        return _regenerator["default"].wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                answerContent = {
                  answer: {
                    sdp: this.peerConn.localDescription.sdp,
                    // type is now deprecated as of Matrix VoIP v1, but
                    // required to still be sent for backwards compat
                    type: this.peerConn.localDescription.type
                  }
                };

                if (this.client._supportsCallTransfer) {
                  answerContent.capabilities = {
                    'm.call.transferee': true
                  };
                } // We have just taken the local description from the peerconnection which will
                // contain all the local candidates added so far, so we can discard any candidates
                // we had queued up because they'll be in the answer.


                _logger.logger.info("Discarding ".concat(this.candidateSendQueue.length, " candidates that will be sent in answer"));

                this.candidateSendQueue = [];
                _context14.prev = 4;
                _context14.next = 7;
                return this.sendVoipEvent(_event.EventType.CallAnswer, answerContent);

              case 7:
                // If this isn't the first time we've tried to send the answer,
                // we may have candidates queued up, so send them now.
                this.inviteOrAnswerSent = true;
                _context14.next = 19;
                break;

              case 10:
                _context14.prev = 10;
                _context14.t0 = _context14["catch"](4);
                // We've failed to answer: back to the ringing state
                this.setState(CallState.Ringing);
                this.client.cancelPendingEvent(_context14.t0.event);
                code = CallErrorCode.SendAnswer;
                message = "Failed to send answer";

                if (_context14.t0.name == 'UnknownDeviceError') {
                  code = CallErrorCode.UnknownDevices;
                  message = "Unknown devices present in the room";
                }

                this.emit(CallEvent.Error, new CallError(code, message, _context14.t0));
                throw _context14.t0;

              case 19:
                // error handler re-throws so this won't happen on error, but
                // we don't want the same error handling on the candidate queue
                this.sendCandidateQueue();

              case 20:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14, this, [[4, 10]]);
      }));

      function sendAnswer() {
        return _sendAnswer.apply(this, arguments);
      }

      return sendAnswer;
    }()
  }, {
    key: "onRemoteIceCandidatesReceived",
    value: function () {
      var _onRemoteIceCandidatesReceived = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee15(ev) {
        var cands, fromPartyId, bufferedCands;
        return _regenerator["default"].wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                if (!this.callHasEnded()) {
                  _context15.next = 2;
                  break;
                }

                return _context15.abrupt("return");

              case 2:
                cands = ev.getContent().candidates;

                if (cands) {
                  _context15.next = 6;
                  break;
                }

                _logger.logger.info("Ignoring candidates event with no candidates!");

                return _context15.abrupt("return");

              case 6:
                fromPartyId = ev.getContent().version === 0 ? null : ev.getContent().party_id || null;

                if (!(this.opponentPartyId === undefined)) {
                  _context15.next = 13;
                  break;
                }

                // we haven't picked an opponent yet so save the candidates
                _logger.logger.info("Bufferring ".concat(cands.length, " candidates until we pick an opponent"));

                bufferedCands = this.remoteCandidateBuffer.get(fromPartyId) || [];
                bufferedCands.push.apply(bufferedCands, (0, _toConsumableArray2["default"])(cands));
                this.remoteCandidateBuffer.set(fromPartyId, bufferedCands);
                return _context15.abrupt("return");

              case 13:
                if (this.partyIdMatches(ev.getContent())) {
                  _context15.next = 16;
                  break;
                }

                _logger.logger.info("Ignoring candidates from party ID ".concat(ev.getContent().party_id, ": ") + "we have chosen party ID ".concat(this.opponentPartyId));

                return _context15.abrupt("return");

              case 16:
                _context15.next = 18;
                return this.addIceCandidates(cands);

              case 18:
              case "end":
                return _context15.stop();
            }
          }
        }, _callee15, this);
      }));

      function onRemoteIceCandidatesReceived(_x12) {
        return _onRemoteIceCandidatesReceived.apply(this, arguments);
      }

      return onRemoteIceCandidatesReceived;
    }()
    /**
     * Used by MatrixClient.
     * @param {Object} msg
     */

  }, {
    key: "onAnswerReceived",
    value: function () {
      var _onAnswerReceived = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee16(event) {
        return _regenerator["default"].wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                _logger.logger.debug("Got answer for call ID ".concat(this.callId, " from party ID ").concat(event.getContent().party_id));

                if (!this.callHasEnded()) {
                  _context16.next = 4;
                  break;
                }

                _logger.logger.debug("Ignoring answer because call ID ".concat(this.callId, " has ended"));

                return _context16.abrupt("return");

              case 4:
                if (!(this.opponentPartyId !== undefined)) {
                  _context16.next = 7;
                  break;
                }

                _logger.logger.info("Ignoring answer from party ID ".concat(event.getContent().party_id, ": ") + "we already have an answer/reject from ".concat(this.opponentPartyId));

                return _context16.abrupt("return");

              case 7:
                this.chooseOpponent(event);
                _context16.next = 10;
                return this.addBufferedIceCandidates();

              case 10:
                this.setState(CallState.Connecting);
                _context16.prev = 11;
                _context16.next = 14;
                return this.peerConn.setRemoteDescription(event.getContent().answer);

              case 14:
                _context16.next = 21;
                break;

              case 16:
                _context16.prev = 16;
                _context16.t0 = _context16["catch"](11);

                _logger.logger.debug("Failed to set remote description", _context16.t0);

                this.terminate(CallParty.Local, CallErrorCode.SetRemoteDescription, false);
                return _context16.abrupt("return");

              case 21:
                if (!(this.opponentPartyId !== null)) {
                  _context16.next = 30;
                  break;
                }

                _context16.prev = 22;
                _context16.next = 25;
                return this.sendVoipEvent(_event.EventType.CallSelectAnswer, {
                  selected_party_id: this.opponentPartyId
                });

              case 25:
                _context16.next = 30;
                break;

              case 27:
                _context16.prev = 27;
                _context16.t1 = _context16["catch"](22);

                // This isn't fatal, and will just mean that if another party has raced to answer
                // the call, they won't know they got rejected, so we carry on & don't retry.
                _logger.logger.warn("Failed to send select_answer event", _context16.t1);

              case 30:
              case "end":
                return _context16.stop();
            }
          }
        }, _callee16, this, [[11, 16], [22, 27]]);
      }));

      function onAnswerReceived(_x13) {
        return _onAnswerReceived.apply(this, arguments);
      }

      return onAnswerReceived;
    }()
  }, {
    key: "onSelectAnswerReceived",
    value: function () {
      var _onSelectAnswerReceived = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee17(event) {
        var selectedPartyId;
        return _regenerator["default"].wrap(function _callee17$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                if (!(this.direction !== CallDirection.Inbound)) {
                  _context17.next = 3;
                  break;
                }

                _logger.logger.warn("Got select_answer for an outbound call: ignoring");

                return _context17.abrupt("return");

              case 3:
                selectedPartyId = event.getContent().selected_party_id;

                if (!(selectedPartyId === undefined || selectedPartyId === null)) {
                  _context17.next = 7;
                  break;
                }

                _logger.logger.warn("Got nonsensical select_answer with null/undefined selected_party_id: ignoring");

                return _context17.abrupt("return");

              case 7:
                if (selectedPartyId !== this.ourPartyId) {
                  _logger.logger.info("Got select_answer for party ID ".concat(selectedPartyId, ": we are party ID ").concat(this.ourPartyId, ".")); // The other party has picked somebody else's answer


                  this.terminate(CallParty.Remote, CallErrorCode.AnsweredElsewhere, true);
                }

              case 8:
              case "end":
                return _context17.stop();
            }
          }
        }, _callee17, this);
      }));

      function onSelectAnswerReceived(_x14) {
        return _onSelectAnswerReceived.apply(this, arguments);
      }

      return onSelectAnswerReceived;
    }()
  }, {
    key: "onNegotiateReceived",
    value: function () {
      var _onNegotiateReceived = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee18(event) {
        var description, polite, offerCollision, prevLocalOnHold, _iterator9, _step9, tranceiver, localDescription, _iterator10, _step10, _tranceiver, newLocalOnHold;

        return _regenerator["default"].wrap(function _callee18$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                description = event.getContent().description;

                if (!(!description || !description.sdp || !description.type)) {
                  _context18.next = 4;
                  break;
                }

                _logger.logger.info("Ignoring invalid m.call.negotiate event");

                return _context18.abrupt("return");

              case 4:
                // Politeness always follows the direction of the call: in a glare situation,
                // we pick either the inbound or outbound call, so one side will always be
                // inbound and one outbound
                polite = this.direction === CallDirection.Inbound; // Here we follow the perfect negotiation logic from
                // https://developer.mozilla.org/en-US/docs/Web/API/WebRTC_API/Perfect_negotiation

                offerCollision = description.type === 'offer' && (this.makingOffer || this.peerConn.signalingState != 'stable');
                this.ignoreOffer = !polite && offerCollision;

                if (!this.ignoreOffer) {
                  _context18.next = 10;
                  break;
                }

                _logger.logger.info("Ignoring colliding negotiate event because we're impolite");

                return _context18.abrupt("return");

              case 10:
                prevLocalOnHold = this.isLocalOnHold();

                if (description.type === 'answer') {
                  // whenever we get an answer back, clear the flag we set whilst trying to un-hold
                  // the other party: the state of the channels now reflects reality
                  this.unholdingRemote = false;
                }

                _context18.prev = 12;
                _context18.next = 15;
                return this.peerConn.setRemoteDescription(description);

              case 15:
                if (!(description.type === 'offer')) {
                  _context18.next = 26;
                  break;
                }

                // First we sent the direction of the tranciever to what we'd like it to be,
                // irresepective of whether the other side has us on hold - so just whether we
                // want the call to be on hold or not. This is necessary because in a few lines,
                // we'll adjust the direction and unless we do this too, we'll never come off hold.
                _iterator9 = _createForOfIteratorHelper(this.peerConn.getTransceivers());

                try {
                  for (_iterator9.s(); !(_step9 = _iterator9.n()).done;) {
                    tranceiver = _step9.value;
                    tranceiver.direction = this.isRemoteOnHold() ? 'inactive' : 'sendrecv';
                  }
                } catch (err) {
                  _iterator9.e(err);
                } finally {
                  _iterator9.f();
                }

                _context18.next = 20;
                return this.peerConn.createAnswer();

              case 20:
                localDescription = _context18.sent;
                _context18.next = 23;
                return this.peerConn.setLocalDescription(localDescription);

              case 23:
                // Now we've got our answer, set the direction to the outcome of the negotiation.
                // We need to do this otherwise Firefox will notice that the direction is not the
                // currentDirection and try to negotiate itself off hold again.
                _iterator10 = _createForOfIteratorHelper(this.peerConn.getTransceivers());

                try {
                  for (_iterator10.s(); !(_step10 = _iterator10.n()).done;) {
                    _tranceiver = _step10.value;
                    _tranceiver.direction = _tranceiver.currentDirection;
                  }
                } catch (err) {
                  _iterator10.e(err);
                } finally {
                  _iterator10.f();
                }

                this.sendVoipEvent(_event.EventType.CallNegotiate, {
                  description: this.peerConn.localDescription
                });

              case 26:
                _context18.next = 31;
                break;

              case 28:
                _context18.prev = 28;
                _context18.t0 = _context18["catch"](12);

                _logger.logger.warn("Failed to complete negotiation", _context18.t0);

              case 31:
                newLocalOnHold = this.isLocalOnHold();

                if (prevLocalOnHold !== newLocalOnHold) {
                  this.emit(CallEvent.LocalHoldUnhold, newLocalOnHold); // also this one for backwards compat

                  this.emit(CallEvent.HoldUnhold, newLocalOnHold);
                }

              case 33:
              case "end":
                return _context18.stop();
            }
          }
        }, _callee18, this, [[12, 28]]);
      }));

      function onNegotiateReceived(_x15) {
        return _onNegotiateReceived.apply(this, arguments);
      }

      return onNegotiateReceived;
    }()
  }, {
    key: "callHasEnded",
    value: function callHasEnded() {
      // This exists as workaround to typescript trying to be clever and erroring
      // when putting if (this.state === CallState.Ended) return; twice in the same
      // function, even though that function is async.
      return this.state === CallState.Ended;
    }
  }, {
    key: "playRemoteAudio",
    value: function () {
      var _playRemoteAudio = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee19() {
        return _regenerator["default"].wrap(function _callee19$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                if (this.remoteVideoElement) this.remoteVideoElement.muted = true;
                this.remoteAudioElement.muted = false;
                this.remoteAudioElement.srcObject = this.remoteStream; // if audioOutput is non-default:

                _context19.prev = 3;

                if (!audioOutput) {
                  _context19.next = 8;
                  break;
                }

                // This seems quite unreliable in Chrome, although I haven't yet managed to make a jsfiddle where
                // it fails.
                // It seems reliable if you set the sink ID after setting the srcObject and then set the sink ID
                // back to the default after the call is over
                _logger.logger.info("Setting audio sink to " + audioOutput + ", was " + this.remoteAudioElement.sinkId);

                _context19.next = 8;
                return this.remoteAudioElement.setSinkId(audioOutput);

              case 8:
                _context19.next = 13;
                break;

              case 10:
                _context19.prev = 10;
                _context19.t0 = _context19["catch"](3);

                _logger.logger.warn("Couldn't set requested audio output device: using default", _context19.t0);

              case 13:
                _context19.prev = 13;
                _context19.next = 16;
                return this.remoteAudioElement.play();

              case 16:
                _context19.next = 21;
                break;

              case 18:
                _context19.prev = 18;
                _context19.t1 = _context19["catch"](13);

                _logger.logger.error("Failed to play remote audio element", _context19.t1);

              case 21:
              case "end":
                return _context19.stop();
            }
          }
        }, _callee19, this, [[3, 10], [13, 18]]);
      }));

      function playRemoteAudio() {
        return _playRemoteAudio.apply(this, arguments);
      }

      return playRemoteAudio;
    }()
  }, {
    key: "playRemoteVideo",
    value: function () {
      var _playRemoteVideo = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee20() {
        return _regenerator["default"].wrap(function _callee20$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                // A note on calling methods on media elements:
                // We used to have queues per media element to serialise all calls on those elements.
                // The reason given for this was that load() and play() were racing. However, we now
                // never call load() explicitly so this seems unnecessary. However, serialising every
                // operation was causing bugs where video would not resume because some play command
                // had got stuck and all media operations were queued up behind it. If necessary, we
                // should serialise the ones that need to be serialised but then be able to interrupt
                // them with another load() which will cancel the pending one, but since we don't call
                // load() explicitly, it shouldn't be a problem.
                this.remoteVideoElement.srcObject = this.remoteStream;

                _logger.logger.info("playing remote video. stream active? " + this.remoteStream.active);

                _context20.prev = 2;
                _context20.next = 5;
                return this.remoteVideoElement.play();

              case 5:
                _context20.next = 10;
                break;

              case 7:
                _context20.prev = 7;
                _context20.t0 = _context20["catch"](2);

                _logger.logger.info("Failed to play remote video element", _context20.t0);

              case 10:
              case "end":
                return _context20.stop();
            }
          }
        }, _callee20, this, [[2, 7]]);
      }));

      function playRemoteVideo() {
        return _playRemoteVideo.apply(this, arguments);
      }

      return playRemoteVideo;
    }()
  }, {
    key: "setState",
    value: function setState(state) {
      var oldState = this.state;
      this.state = state;
      this.emit(CallEvent.State, state, oldState);
    }
    /**
     * Internal
     * @param {string} eventType
     * @param {Object} content
     * @return {Promise}
     */

  }, {
    key: "sendVoipEvent",
    value: function sendVoipEvent(eventType, content) {
      return this.client.sendEvent(this.roomId, eventType, Object.assign({}, content, {
        version: VOIP_PROTO_VERSION,
        call_id: this.callId,
        party_id: this.ourPartyId
      }));
    }
  }, {
    key: "queueCandidate",
    value: function queueCandidate(content) {
      var _this4 = this;

      // Sends candidates with are sent in a special way because we try to amalgamate
      // them into one message
      this.candidateSendQueue.push(content); // Don't send the ICE candidates yet if the call is in the ringing state: this
      // means we tried to pick (ie. started generating candidates) and then failed to
      // send the answer and went back to the ringing state. Queue up the candidates
      // to send if we sucessfully send the answer.
      // Equally don't send if we haven't yet sent the answer because we can send the
      // first batch of candidates along with the answer

      if (this.state === CallState.Ringing || !this.inviteOrAnswerSent) return; // MSC2746 reccomends these values (can be quite long when calling because the
      // callee will need a while to answer the call)

      var delay = this.direction === CallDirection.Inbound ? 500 : 2000;

      if (this.candidateSendTries === 0) {
        setTimeout(function () {
          _this4.sendCandidateQueue();
        }, delay);
      }
    }
    /*
     * Transfers this call to another user
     */

  }, {
    key: "transfer",
    value: function () {
      var _transfer = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee21(targetUserId) {
        var profileInfo, replacementId, body;
        return _regenerator["default"].wrap(function _callee21$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                _context21.next = 2;
                return this.client.getProfileInfo(targetUserId);

              case 2:
                profileInfo = _context21.sent;
                replacementId = genCallID();
                body = {
                  replacement_id: genCallID(),
                  target_user: {
                    id: targetUserId,
                    display_name: profileInfo.display_name,
                    avatar_url: profileInfo.avatar_url
                  },
                  create_call: replacementId
                };
                _context21.next = 7;
                return this.sendVoipEvent(_event.EventType.CallReplaces, body);

              case 7:
                _context21.next = 9;
                return this.terminate(CallParty.Local, CallErrorCode.Replaced, true);

              case 9:
              case "end":
                return _context21.stop();
            }
          }
        }, _callee21, this);
      }));

      function transfer(_x16) {
        return _transfer.apply(this, arguments);
      }

      return transfer;
    }()
    /*
     * Transfers this call to the target call, effectively 'joining' the
     * two calls (so the remote parties on each call are connected together).
     */

  }, {
    key: "transferToCall",
    value: function () {
      var _transferToCall = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee22(transferTargetCall) {
        var targetProfileInfo, transfereeProfileInfo, newCallId, bodyToTransferTarget, bodyToTransferee;
        return _regenerator["default"].wrap(function _callee22$(_context22) {
          while (1) {
            switch (_context22.prev = _context22.next) {
              case 0:
                _context22.next = 2;
                return this.client.getProfileInfo(transferTargetCall.getOpponentMember().userId);

              case 2:
                targetProfileInfo = _context22.sent;
                _context22.next = 5;
                return this.client.getProfileInfo(this.getOpponentMember().userId);

              case 5:
                transfereeProfileInfo = _context22.sent;
                newCallId = genCallID();
                bodyToTransferTarget = {
                  // the replacements on each side have their own ID, and it's distinct from the
                  // ID of the new call (but we can use the same function to generate it)
                  replacement_id: genCallID(),
                  target_user: {
                    id: this.getOpponentMember().userId,
                    display_name: transfereeProfileInfo.display_name,
                    avatar_url: transfereeProfileInfo.avatar_url
                  },
                  await_call: newCallId
                };
                _context22.next = 10;
                return transferTargetCall.sendVoipEvent(_event.EventType.CallReplaces, bodyToTransferTarget);

              case 10:
                bodyToTransferee = {
                  replacement_id: genCallID(),
                  target_user: {
                    id: transferTargetCall.getOpponentMember().userId,
                    display_name: targetProfileInfo.display_name,
                    avatar_url: targetProfileInfo.avatar_url
                  },
                  create_call: newCallId
                };
                _context22.next = 13;
                return this.sendVoipEvent(_event.EventType.CallReplaces, bodyToTransferee);

              case 13:
                _context22.next = 15;
                return this.terminate(CallParty.Local, CallErrorCode.Replaced, true);

              case 15:
                _context22.next = 17;
                return transferTargetCall.terminate(CallParty.Local, CallErrorCode.Replaced, true);

              case 17:
              case "end":
                return _context22.stop();
            }
          }
        }, _callee22, this);
      }));

      function transferToCall(_x17) {
        return _transferToCall.apply(this, arguments);
      }

      return transferToCall;
    }()
  }, {
    key: "terminate",
    value: function () {
      var _terminate = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee23(hangupParty, hangupReason, shouldEmit) {
        var remoteVid, remoteAud, localVid;
        return _regenerator["default"].wrap(function _callee23$(_context23) {
          while (1) {
            switch (_context23.prev = _context23.next) {
              case 0:
                if (!this.callHasEnded()) {
                  _context23.next = 2;
                  break;
                }

                return _context23.abrupt("return");

              case 2:
                _context23.next = 4;
                return this.collectCallStats();

              case 4:
                this.callStatsAtEnd = _context23.sent;

                if (this.inviteTimeout) {
                  clearTimeout(this.inviteTimeout);
                  this.inviteTimeout = null;
                }

                remoteVid = this.getRemoteVideoElement();
                remoteAud = this.getRemoteAudioElement();
                localVid = this.getLocalVideoElement();

                if (remoteVid) {
                  remoteVid.pause();
                  remoteVid.srcObject = null;
                }

                if (!remoteAud) {
                  _context23.next = 21;
                  break;
                }

                remoteAud.pause();
                remoteAud.srcObject = null;
                _context23.prev = 13;
                _context23.next = 16;
                return this.remoteAudioElement.setSinkId('');

              case 16:
                _context23.next = 21;
                break;

              case 18:
                _context23.prev = 18;
                _context23.t0 = _context23["catch"](13);

                _logger.logger.warn("Failed to set sink ID back to default");

              case 21:
                if (localVid) {
                  localVid.pause();
                  localVid.srcObject = null;
                }

                this.hangupParty = hangupParty;
                this.hangupReason = hangupReason;
                this.setState(CallState.Ended);
                this.stopAllMedia();

                if (this.peerConn && this.peerConn.signalingState !== 'closed') {
                  this.peerConn.close();
                }

                if (shouldEmit) {
                  this.emit(CallEvent.Hangup, this);
                }

              case 28:
              case "end":
                return _context23.stop();
            }
          }
        }, _callee23, this, [[13, 18]]);
      }));

      function terminate(_x18, _x19, _x20) {
        return _terminate.apply(this, arguments);
      }

      return terminate;
    }()
  }, {
    key: "stopAllMedia",
    value: function stopAllMedia() {
      _logger.logger.debug("stopAllMedia (stream=".concat(this.localAVStream, ")"));

      if (this.localAVStream) {
        var _iterator11 = _createForOfIteratorHelper(this.localAVStream.getTracks()),
            _step11;

        try {
          for (_iterator11.s(); !(_step11 = _iterator11.n()).done;) {
            var track = _step11.value;
            track.stop();
          }
        } catch (err) {
          _iterator11.e(err);
        } finally {
          _iterator11.f();
        }
      }

      if (this.screenSharingStream) {
        var _iterator12 = _createForOfIteratorHelper(this.screenSharingStream.getTracks()),
            _step12;

        try {
          for (_iterator12.s(); !(_step12 = _iterator12.n()).done;) {
            var _track = _step12.value;

            _track.stop();
          }
        } catch (err) {
          _iterator12.e(err);
        } finally {
          _iterator12.f();
        }
      }

      if (this.remoteStream) {
        var _iterator13 = _createForOfIteratorHelper(this.remoteStream.getTracks()),
            _step13;

        try {
          for (_iterator13.s(); !(_step13 = _iterator13.n()).done;) {
            var _track2 = _step13.value;

            _track2.stop();
          }
        } catch (err) {
          _iterator13.e(err);
        } finally {
          _iterator13.f();
        }
      }
    }
  }, {
    key: "checkForErrorListener",
    value: function checkForErrorListener() {
      if (this.listeners("error").length === 0) {
        throw new Error("You MUST attach an error listener using call.on('error', function() {})");
      }
    }
  }, {
    key: "sendCandidateQueue",
    value: function () {
      var _sendCandidateQueue = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee24() {
        var _this5 = this;

        var cands, content, _this$candidateSendQu, code, message, delayMs;

        return _regenerator["default"].wrap(function _callee24$(_context24) {
          while (1) {
            switch (_context24.prev = _context24.next) {
              case 0:
                if (!(this.candidateSendQueue.length === 0)) {
                  _context24.next = 2;
                  break;
                }

                return _context24.abrupt("return");

              case 2:
                cands = this.candidateSendQueue;
                this.candidateSendQueue = [];
                ++this.candidateSendTries;
                content = {
                  candidates: cands
                };

                _logger.logger.debug("Attempting to send " + cands.length + " candidates");

                _context24.prev = 7;
                _context24.next = 10;
                return this.sendVoipEvent(_event.EventType.CallCandidates, content);

              case 10:
                _context24.next = 27;
                break;

              case 12:
                _context24.prev = 12;
                _context24.t0 = _context24["catch"](7);
                // don't retry this event: we'll send another one later as we might
                // have more candidates by then.
                if (_context24.t0.event) this.client.cancelPendingEvent(_context24.t0.event); // put all the candidates we failed to send back in the queue

                (_this$candidateSendQu = this.candidateSendQueue).push.apply(_this$candidateSendQu, (0, _toConsumableArray2["default"])(cands));

                if (!(this.candidateSendTries > 5)) {
                  _context24.next = 23;
                  break;
                }

                _logger.logger.debug("Failed to send candidates on attempt " + this.candidateSendTries + ". Giving up on this call.", _context24.t0);

                code = CallErrorCode.SignallingFailed;
                message = "Signalling failed";
                this.emit(CallEvent.Error, new CallError(code, message, _context24.t0));
                this.hangup(code, false);
                return _context24.abrupt("return");

              case 23:
                delayMs = 500 * Math.pow(2, this.candidateSendTries);
                ++this.candidateSendTries;

                _logger.logger.debug("Failed to send candidates. Retrying in " + delayMs + "ms", _context24.t0);

                setTimeout(function () {
                  _this5.sendCandidateQueue();
                }, delayMs);

              case 27:
              case "end":
                return _context24.stop();
            }
          }
        }, _callee24, this, [[7, 12]]);
      }));

      function sendCandidateQueue() {
        return _sendCandidateQueue.apply(this, arguments);
      }

      return sendCandidateQueue;
    }()
  }, {
    key: "placeCallWithConstraints",
    value: function () {
      var _placeCallWithConstraints = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee25(constraints) {
        var haveTurnCreds, mediaStream;
        return _regenerator["default"].wrap(function _callee25$(_context25) {
          while (1) {
            switch (_context25.prev = _context25.next) {
              case 0:
                _logger.logger.log("Getting user media with constraints", constraints); // XXX Find a better way to do this


                this.client._callEventHandler.calls.set(this.callId, this);

                this.setState(CallState.WaitLocalMedia);
                this.direction = CallDirection.Outbound;
                this.config = constraints; // make sure we have valid turn creds. Unless something's gone wrong, it should
                // poll and keep the credentials valid so this should be instant.

                _context25.next = 7;
                return this.client._checkTurnServers();

              case 7:
                haveTurnCreds = _context25.sent;

                if (!haveTurnCreds) {
                  _logger.logger.warn("Failed to get TURN credentials! Proceeding with call anyway...");
                } // create the peer connection now so it can be gathering candidates while we get user
                // media (assuming a candidate pool size is configured)


                this.peerConn = this.createPeerConnection();
                _context25.prev = 10;
                _context25.next = 13;
                return navigator.mediaDevices.getUserMedia(constraints);

              case 13:
                mediaStream = _context25.sent;
                this.gotUserMediaForInvite(mediaStream);
                _context25.next = 21;
                break;

              case 17:
                _context25.prev = 17;
                _context25.t0 = _context25["catch"](10);
                this.getUserMediaFailed(_context25.t0);
                return _context25.abrupt("return");

              case 21:
              case "end":
                return _context25.stop();
            }
          }
        }, _callee25, this, [[10, 17]]);
      }));

      function placeCallWithConstraints(_x21) {
        return _placeCallWithConstraints.apply(this, arguments);
      }

      return placeCallWithConstraints;
    }()
  }, {
    key: "createPeerConnection",
    value: function createPeerConnection() {
      var pc = new window.RTCPeerConnection({
        iceTransportPolicy: this.forceTURN ? 'relay' : undefined,
        iceServers: this.turnServers,
        iceCandidatePoolSize: this.client._iceCandidatePoolSize
      }); // 'connectionstatechange' would be better, but firefox doesn't implement that.

      pc.addEventListener('iceconnectionstatechange', this.onIceConnectionStateChanged);
      pc.addEventListener('signalingstatechange', this.onSignallingStateChanged);
      pc.addEventListener('icecandidate', this.gotLocalIceCandidate);
      pc.addEventListener('icegatheringstatechange', this.onIceGatheringStateChange);
      pc.addEventListener('track', this.onTrack);
      pc.addEventListener('negotiationneeded', this.onNegotiationNeeded);
      return pc;
    }
  }, {
    key: "partyIdMatches",
    value: function partyIdMatches(msg) {
      // They must either match or both be absent (in which case opponentPartyId will be null)
      // Also we ignore party IDs on the invite/offer if the version is 0, so we must do the same
      // here and use null if the version is 0 (woe betide any opponent sending messages in the
      // same call with different versions)
      var msgPartyId = msg.version === 0 ? null : msg.party_id || null;
      return msgPartyId === this.opponentPartyId;
    } // Commits to an opponent for the call
    // ev: An invite or answer event

  }, {
    key: "chooseOpponent",
    value: function chooseOpponent(ev) {
      // I choo-choo-choose you
      var msg = ev.getContent();

      _logger.logger.debug("Choosing party ID ".concat(msg.party_id, " for call ID ").concat(this.callId));

      this.opponentVersion = msg.version;

      if (this.opponentVersion === 0) {
        // set to null to indicate that we've chosen an opponent, but because
        // they're v0 they have no party ID (even if they sent one, we're ignoring it)
        this.opponentPartyId = null;
      } else {
        // set to their party ID, or if they're naughty and didn't send one despite
        // not being v0, set it to null to indicate we picked an opponent with no
        // party ID
        this.opponentPartyId = msg.party_id || null;
      }

      this.opponentCaps = msg.capabilities || {};
      this.opponentMember = ev.sender;
    }
  }, {
    key: "addBufferedIceCandidates",
    value: function () {
      var _addBufferedIceCandidates = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee26() {
        var bufferedCands;
        return _regenerator["default"].wrap(function _callee26$(_context26) {
          while (1) {
            switch (_context26.prev = _context26.next) {
              case 0:
                bufferedCands = this.remoteCandidateBuffer.get(this.opponentPartyId);

                if (!bufferedCands) {
                  _context26.next = 5;
                  break;
                }

                _logger.logger.info("Adding ".concat(bufferedCands.length, " buffered candidates for opponent ").concat(this.opponentPartyId));

                _context26.next = 5;
                return this.addIceCandidates(bufferedCands);

              case 5:
                this.remoteCandidateBuffer = null;

              case 6:
              case "end":
                return _context26.stop();
            }
          }
        }, _callee26, this);
      }));

      function addBufferedIceCandidates() {
        return _addBufferedIceCandidates.apply(this, arguments);
      }

      return addBufferedIceCandidates;
    }()
  }, {
    key: "addIceCandidates",
    value: function () {
      var _addIceCandidates = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee27(cands) {
        var _iterator14, _step14, cand;

        return _regenerator["default"].wrap(function _callee27$(_context27) {
          while (1) {
            switch (_context27.prev = _context27.next) {
              case 0:
                _iterator14 = _createForOfIteratorHelper(cands);
                _context27.prev = 1;

                _iterator14.s();

              case 3:
                if ((_step14 = _iterator14.n()).done) {
                  _context27.next = 19;
                  break;
                }

                cand = _step14.value;

                if (!((cand.sdpMid === null || cand.sdpMid === undefined) && (cand.sdpMLineIndex === null || cand.sdpMLineIndex === undefined))) {
                  _context27.next = 8;
                  break;
                }

                _logger.logger.debug("Ignoring remote ICE candidate with no sdpMid or sdpMLineIndex");

                return _context27.abrupt("continue", 17);

              case 8:
                _logger.logger.debug("Call " + this.callId + " got remote ICE " + cand.sdpMid + " candidate: " + cand.candidate);

                _context27.prev = 9;
                _context27.next = 12;
                return this.peerConn.addIceCandidate(cand);

              case 12:
                _context27.next = 17;
                break;

              case 14:
                _context27.prev = 14;
                _context27.t0 = _context27["catch"](9);

                if (!this.ignoreOffer) {
                  _logger.logger.info("Failed to add remote ICE candidate", _context27.t0);
                }

              case 17:
                _context27.next = 3;
                break;

              case 19:
                _context27.next = 24;
                break;

              case 21:
                _context27.prev = 21;
                _context27.t1 = _context27["catch"](1);

                _iterator14.e(_context27.t1);

              case 24:
                _context27.prev = 24;

                _iterator14.f();

                return _context27.finish(24);

              case 27:
              case "end":
                return _context27.stop();
            }
          }
        }, _callee27, this, [[1, 21, 24, 27], [9, 14]]);
      }));

      function addIceCandidates(_x22) {
        return _addIceCandidates.apply(this, arguments);
      }

      return addIceCandidates;
    }()
  }]);
  return MatrixCall;
}(_events.EventEmitter);

exports.MatrixCall = MatrixCall;

function setTracksEnabled(tracks, enabled) {
  for (var i = 0; i < tracks.length; i++) {
    tracks[i].enabled = enabled;
  }
}

function getUserMediaContraints(type) {
  var isWebkit = !!navigator.webkitGetUserMedia;

  switch (type) {
    case ConstraintsType.Audio:
      {
        return {
          audio: {
            deviceId: audioInput ? {
              ideal: audioInput
            } : undefined
          },
          video: false
        };
      }

    case ConstraintsType.Video:
      {
        return {
          audio: {
            deviceId: audioInput ? {
              ideal: audioInput
            } : undefined
          },
          video: {
            deviceId: videoInput ? {
              ideal: videoInput
            } : undefined,

            /* We want 640x360.  Chrome will give it only if we ask exactly,
               FF refuses entirely if we ask exactly, so have to ask for ideal
               instead
               XXX: Is this still true?
             */
            width: isWebkit ? {
              exact: 640
            } : {
              ideal: 640
            },
            height: isWebkit ? {
              exact: 360
            } : {
              ideal: 360
            }
          }
        };
      }
  }
}

function getScreenshareContraints(_x23) {
  return _getScreenshareContraints.apply(this, arguments);
}

function _getScreenshareContraints() {
  _getScreenshareContraints = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee28(selectDesktopCapturerSource) {
    var _window$electron2;

    var selectedSource;
    return _regenerator["default"].wrap(function _callee28$(_context28) {
      while (1) {
        switch (_context28.prev = _context28.next) {
          case 0:
            if (!((_window$electron2 = window.electron) !== null && _window$electron2 !== void 0 && _window$electron2.getDesktopCapturerSources && selectDesktopCapturerSource)) {
              _context28.next = 10;
              break;
            }

            // We have access to getDesktopCapturerSources()
            _logger.logger.debug("Electron getDesktopCapturerSources() is available...");

            _context28.next = 4;
            return selectDesktopCapturerSource();

          case 4:
            selectedSource = _context28.sent;

            if (selectedSource) {
              _context28.next = 7;
              break;
            }

            return _context28.abrupt("return", null);

          case 7:
            return _context28.abrupt("return", {
              audio: false,
              video: {
                mandatory: {
                  chromeMediaSource: "desktop",
                  chromeMediaSourceId: selectedSource.id
                }
              }
            });

          case 10:
            // We do not have access to the Electron desktop capturer,
            // therefore we can assume we are on the web
            _logger.logger.debug("Electron desktopCapturer is not available...");

            return _context28.abrupt("return", {
              audio: false,
              video: true
            });

          case 12:
          case "end":
            return _context28.stop();
        }
      }
    }, _callee28);
  }));
  return _getScreenshareContraints.apply(this, arguments);
}

var audioOutput;
var audioInput;
var videoInput;
/**
 * Set an audio output device to use for MatrixCalls
 * @function
 * @param {string=} deviceId the identifier for the device
 * undefined treated as unset
 */

function setAudioOutput(deviceId) {
  audioOutput = deviceId;
}
/**
 * Set an audio input device to use for MatrixCalls
 * @function
 * @param {string=} deviceId the identifier for the device
 * undefined treated as unset
 */


function setAudioInput(deviceId) {
  audioInput = deviceId;
}
/**
 * Set a video input device to use for MatrixCalls
 * @function
 * @param {string=} deviceId the identifier for the device
 * undefined treated as unset
 */


function setVideoInput(deviceId) {
  videoInput = deviceId;
}
/**
 * Create a new Matrix call for the browser.
 * @param {MatrixClient} client The client instance to use.
 * @param {string} roomId The room the call is in.
 * @param {Object?} options DEPRECATED optional options map.
 * @param {boolean} options.forceTURN DEPRECATED whether relay through TURN should be
 * forced. This option is deprecated - use opts.forceTURN when creating the matrix client
 * since it's only possible to set this option on outbound calls.
 * @return {MatrixCall} the call or null if the browser doesn't support calling.
 */


function createNewMatrixCall(client, roomId, options) {
  // typeof prevents Node from erroring on an undefined reference
  if (typeof window === 'undefined' || typeof document === 'undefined') {
    // NB. We don't log here as apps try to create a call object as a test for
    // whether calls are supported, so we shouldn't fill the logs up.
    return null;
  } // Firefox throws on so little as accessing the RTCPeerConnection when operating in
  // a secure mode. There's some information at https://bugzilla.mozilla.org/show_bug.cgi?id=1542616
  // though the concern is that the browser throwing a SecurityError will brick the
  // client creation process.


  try {
    var supported = Boolean(window.RTCPeerConnection || window.RTCSessionDescription || window.RTCIceCandidate || navigator.mediaDevices);

    if (!supported) {
      _logger.logger.error("WebRTC is not supported in this browser / environment");

      return null;
    }
  } catch (e) {
    _logger.logger.error("Exception thrown when trying to access WebRTC", e);

    return null;
  }

  var optionsForceTURN = options ? options.forceTURN : false;
  var opts = {
    client: client,
    roomId: roomId,
    turnServers: client.getTurnServers(),
    // call level options
    forceTURN: client._forceTURN || optionsForceTURN
  };
  var call = new MatrixCall(opts);
  client.reEmitter.reEmit(call, Object.values(CallEvent));
  return call;
}